chiark / gitweb /
test suite: Introduce t-expect-fsck-fail
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 funcs: ${FUNCNAME[*]}
16 lines: ${BASH_LINENO[*]}
17 files: ${BASH_SOURCE[*]}
18 END
19         exit 16
20 }
21
22 trap 'test $? = 0 || t-report-failure' EXIT
23
24 t-filter-out-git-hyphen-dir
25
26 t-set-intree
27
28 : ${DGIT_TEST_DEBUG=-D}
29 export DGIT_TEST_DEBUG
30
31 export GIT_COMMITTER_DATE='1440253867 +0100'
32 export GIT_AUTHOR_DATE='1440253867 +0100'
33
34 root=`pwd`
35 troot=$root/tests
36 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
37
38 tmp=$ADTTMP
39 if [ x"$tmp" = x ]; then
40         mkdir -p tests/tmp
41         tmpbase=$troot/tmp
42         tmp=tests/tmp/$testname
43         rm -rf $tmp
44         mkdir $tmp
45 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
46         tmpbase="$DGIT_TEST_TMPBASE"
47 fi
48 cd $tmp
49
50 tmp=`pwd`
51
52 t-set-using-tmp
53
54 env -0 >$tmp/.save-env
55
56 ln -f $troot/ssh ssh
57
58 export DEBCHANGE_VENDOR=dpkg
59
60 mkdir -p $tmp/incoming
61 cat <<END >$tmp/dput.cf
62 [test-dummy]
63 method                  = local
64 incoming                = $tmp/incoming
65 run_dinstall            = 0
66 END
67
68 : ${t_archive_method:=aq}
69 : ${tagpfx:=archive/test-dummy}
70 : ${suitespecs:=sid:unstable}
71
72 t-git-next-date () {
73         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
74         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
75 }
76
77 t-expect-fail () {
78         local mpat="$1"; shift
79
80         set +o pipefail
81         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
82         local ps="${PIPESTATUS[*]}"
83         set -o pipefail
84
85         case $ps in
86         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
87         *" 0")  ;;
88         *)      fail "tee failed"  ;;
89         esac
90
91         t-grep-mpat "$mpat" $tmp/t.output
92 }
93
94 t-grep-mpat () {
95         local mpat="$1"
96         local file="$2"
97
98         local grepper=fgrep
99         case "$mpat" in
100         [A-Z]:*)
101                 case "$mpat" in
102                 E:*)    grepper=egrep   ;;
103                 F:*)    grepper=fgrep   ;;
104                 *)      fail "bad mpat prefix in $mpat";;
105                 esac
106                 mpat=${mpat#[A-Z]:}
107                 ;;
108         esac
109
110         $grepper -e "$mpat" "$file" ||
111                 fail "message not found"
112 }
113
114 t-expect-push-fail () {
115         local mpat="$1"; shift
116
117         local triedpush=`git rev-parse HEAD`
118
119         t-reporefs pre-push
120         t-expect-fail "$mpat"  "$@"
121         t-reporefs post-push
122         diff $tmp/show-refs.{pre,post}-push
123
124         t-git-objects-not-present '' $triedpush
125
126         eval "$t_expect_push_fail_hook"
127 }
128
129 t-git-objects-not-present () {
130         # t-git-objects-not-present GITDIR|'' OBJID [...]
131         # specifying '' means the repo for package $p
132         local gitdir="${1-$dgitrepo}"
133         local obj
134         if ! [ -e "$gitdir" ]; then return; fi
135         for obj in "$@"; do
136                 GIT_DIR=$gitdir \
137                 t-expect-fail 'unable to find' \
138                 git cat-file -t $obj
139         done
140 }
141
142 t-reporefs () {
143         local whichoutput=$1; shift
144         local whichrepo=${1-$dgitrepo}
145         local outputfile="$tmp/show-refs.$whichoutput"
146         (set -e
147          exec >"$outputfile"
148          if test -d $whichrepo; then
149                 cd $whichrepo
150                 git show-ref |sort
151         fi)
152 }
153
154 t-untar () {
155         local tarfile=$1.tar
156         local edittree=$1.edit
157         if test -d "$edittree"; then
158                 cp -a "$edittree"/* .
159         else
160                 tar xf "$tarfile"
161         fi
162 }
163
164 t-worktree () {
165         rm -rf $p
166         t-untar $troot/worktrees/${p}_$1
167 }
168
169 t-select-package () {
170         p=$1
171         dgitrepo=$tmp/git/$p.git
172 }
173
174 t-git () {
175         t-select-package $1
176         v=$2
177         mkdir -p $tmp/git
178         local gs=$troot/git-srcs/${p}_$v.git
179         (set -e; cd $tmp/git; t-untar $gs)
180 }
181
182 t-git-none () {
183         mkdir -p $tmp/git
184         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
185 }
186
187 t-git-merge-base () {
188         git merge-base $1 $2 || test $? = 1
189 }
190
191 t-has-ancestor () {
192         # t-has-ancestor ANCESTOR
193         # (CHILD is implicit, HEAD)
194         local now=`git rev-parse HEAD`
195         local ancestor=`git rev-parse $1^{}`
196         local mbase=`t-git-merge-base $ancestor $now`
197         if [ x$mbase != x$ancestor ]; then
198                 fail "not ff $ancestor..$now, $mbase != $ancestor"
199         fi
200 }
201
202 t-has-parent-or-is () {
203         # t-has-parent-or-is CHILD PARENT
204         local child=$1
205         local parent=$2
206         local parents=$(git show --pretty=format:' %P %H ' "$child")
207         parent=$(git rev-parse "$parent~0")
208         case "$parents" in
209         *" $parent "*)  ;;
210         *)      fail "child $child lacks parent $parent" ;;
211         esac
212 }
213
214 t-prep-newpackage () {
215         t-select-package $1
216         v=$2
217         t-archive-none $p
218         t-git-none
219         t-worktree $v
220         cd $p
221         if ! git show-ref --verify --quiet refs/heads/master; then
222                 git branch -m dgit/sid master
223                 git remote rm dgit
224         fi
225         cd ..
226 }
227
228 t-archive-none () {
229         t-select-package $1
230         t-archive-none-$t_archive_method
231 }
232 t-archive-none-aq () {
233         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
234
235         : >$tmp/aq/suites
236         local jsondelim="["
237
238         local suitespec
239         for suitespec in $suitespecs; do
240                 local suite=${suitespec%%:*}
241                 local sname=${suitespec#*:}
242
243                 >$tmp/aq/package.$suite.$p
244                 t-aq-archive-updated $suite $p
245
246                 >$tmp/aq/package.new.$p
247                 t-aq-archive-updated new $p
248
249                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
250
251                 cat <<END >>$tmp/aq/suites
252 $jsondelim
253    {
254       "archive" : "ftp-master",
255       "codename" : "$suite",
256       "components" : [
257          "main",
258          "contrib",
259          "non-free"
260       ],
261       "name" : "$sname",
262       "dakname" : "$sname"
263 END
264
265                 jsondelim="   },"
266
267         done
268         cat <<END >>$tmp/aq/suites
269     }
270 ]
271 END
272 }
273
274 t-aq-archive-updated () {
275         local suite=$1
276         local p=$2
277         local suitedir=$tmp/aq/dsc_in_suite/$suite
278         mkdir -p $suitedir
279         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
280                 use JSON;
281                 use strict;
282                 our @v;
283                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
284                 push @v, {
285                         "version" => "$1",
286                         "sha256sum" => "$2",
287                         "component" => "$3",
288                         "filename" => "$4",
289                 };
290                 END {
291                         my $json = JSON->new->canonical();
292                         print $json->encode(\@v) or die $!;
293                 }
294         '
295 }
296
297 t-archive-process-incoming () {
298         local suite=$1
299         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
300         t-archive-query "$suite"
301 }
302
303 t-archive-query () {
304         local suite=${1-sid}
305         local dscf=main/${p}_${v}.dsc
306         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
307 }
308 t-archive-query-aq () {
309         local suite=$1
310         local p=$2
311         local v=$3
312         local dscf=$4
313         local sha=`sha256sum <$tmp/mirror/pool/$dscf`
314         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
315         t-aq-archive-updated $suite $p
316 }
317
318 t-archive () {
319         t-archive-none $1
320         v=$2
321         local dscf=${p}_$2.dsc
322         rm -f $tmp/mirror/pool/main/${p}_*
323         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
324         t-archive-query $suite
325         rm -rf $tmp/extract
326         mkdir $tmp/extract
327         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
328 }
329
330 t-git-dir-time-passes () {
331         touch -d 'last year' $dgitrepo
332 }
333
334 t-git-dir-check () {
335         local gitdir=$dgitrepo
336         case "$1" in
337         enoent)
338                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
339                 return
340                 ;;
341         public) wantstat='7[75]5' ;;
342         secret) wantstat='7[70]0' ;;
343         *)      fail "$1 t-git-dir-check ?" ;;
344         esac
345         gotstat=`stat -c%a $gitdir`
346         case "$gotstat" in
347         *$wantstat) return ;;
348         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
349         esac
350 }
351
352 t-expect-fsck-fail () {
353         expect_fsck_fail+=" $1"
354 }
355
356 t-git-fsck () {
357         git fsck --no-dangling --strict || ${expect_fsck_fail:+true} false
358 }
359
360 t-fscks () {
361         (
362         shopt -s nullglob
363         for d in $tmp/*/.git $tmp/git/*.git; do
364                 cd "$d"
365                 t-git-fsck
366         done
367         )
368 }
369
370 t-ok () {
371         t-fscks
372         echo ok.
373 }
374
375 t-rm-dput-dropping () {
376         rm -f $tmp/${p}_${v}_*.upload
377 }
378
379 t-dgit () {
380         local dgit=${DGIT_TEST-dgit}
381         pwd
382         : '
383 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
384         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
385                 -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
386                 -k39B13D8A $t_dgit_xopts "$@"
387         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
388 '
389 }
390
391 t-diff-nogit () {
392         diff --exclude=.git --exclude=.pc -ruN $*
393 }
394
395 t-files-notexist () {
396         local f
397         for f in "$@"; do
398                 if [ -e $f ]; then
399                         fail "$f exists!"
400                 fi
401         done
402 }
403
404 t-cloned-fetched-good () {
405         t-diff-nogit ../extract/$p-${v%-*} .
406         t-clean-on-branch dgit/sid
407         t-refs-same-start
408         t-refs-same \
409                 refs/heads/dgit/sid \
410                 refs/remotes/dgit/dgit/sid
411         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
412 }
413
414 t-output () {
415         printf "%s${1:+\n}" "$1" >$tmp/t.want
416         shift
417         "$@" >$tmp/t.got
418         diff $tmp/t.want $tmp/t.got
419 }
420
421 t-clean-on-branch () {
422         t-output "## $1" git status -b --porcelain
423 }
424
425 t-setup-done () {
426         local savevars=$1
427         local savedirs=$2
428         local importeval=$3
429
430         local import=IMPORT.${0##*/}
431         exec 4>$tmp/$import.new
432
433         local vn
434         for vn in $savevars; do
435                 perl >&4 -I. -MDebian::Dgit -e '
436                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
437                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
438         done
439
440         (set -e; cd $tmp; tar cf $import.tar $savedirs)
441
442         printf >&4 "\n%s\n" "$importeval"
443
444         mv -f $tmp/$import.new $tmp/$import
445 }
446
447 t-setup-import () {
448         local setupname=$1
449
450         local setupsrc
451         local lock
452         if [ "x$tmpbase" = x ]; then
453                 # ADTTMP was set on entry to tests/lib, so we
454                 # are not sharing tmp area between tests
455                 setupsrc="$tmp"
456                 lock="$tmp/.dummy.lock"
457         else
458                 setupsrc="$tmpbase/$setupname"
459                 lock="$setupsrc.lock"
460         fi
461
462         local simport="$setupsrc/IMPORT.$setupname"
463
464         if ! [ -e "$simport" ]; then
465                 with-lock-ex -w "$lock" \
466                 xargs -0 -a $tmp/.save-env \
467                 bash -xec '
468                         cd "$1"; shift
469                         setupname="$1"; shift
470                         simport="$1"; shift
471                         if [ -e "$simport" ]; then exit 0; fi
472                         env - "$@" \
473                         "tests/setup/$setupname"
474                 ' x "$root" "$setupname" "$simport"
475         fi
476
477         if [ "x$setupsrc" != "x$tmp" ]; then
478                 (set -e; cd $tmp; tar xf "$simport.tar")
479         fi
480
481         . "$simport"
482 }
483
484 t-git-get-ref-exact () {
485         local ref=$1
486         # does not dereference, unlike t-git-get-ref
487         case "$ref" in
488         refs/*) ;;
489         *) fail "t-git-get-ref-exact bad $ref" ;;
490         esac
491         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
492 }
493
494 t-git-get-ref () {
495         local ref=$1
496         case "$ref" in
497         refs/*) ;;
498         *) fail "t-git-get-ref bad $ref" ;;
499         esac
500         (git show-ref -d $1 || test $? = 1) | perl -ne '
501                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
502                 END { print "$x\n" if length $x; }
503         '
504 }
505
506 t-ref-same-exact () {
507         local name="$1"
508         local val=`t-git-get-ref-exact $name`
509         t-ref-same-val "$name" $val
510 }
511
512 t-ref-same () {
513         local name="$1"
514         local val=`t-git-get-ref $name`
515         t-ref-same-val "$name" $val
516 }
517
518 t-ref-head () {
519         local val=`git rev-parse HEAD`
520         t-ref-same-val HEAD $val
521 }
522
523 t-ref-same-val () {
524         local name="$1"
525         local val=$2
526         case "${t_ref_val-unset}" in
527         unset)          ;;
528         "$val")         ;;
529         *)              fail "ref varies: ($name)\
530  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
531         esac
532         t_ref_val="$val"
533         t_ref_names+=("$name")
534 }
535
536 t-refs-same-start () {
537         unset t_ref_val
538         t_ref_names=()
539 }
540
541 t-refs-same () {
542         local g
543         for g in $*; do
544                 t-ref-same $g
545         done
546 }
547
548 t-refs-notexist () {
549         local val
550         for g in $*; do
551                 val=`t-git-get-ref $g`
552                 if [ "x$val" != x ]; then
553                         fail "ref $g unexpectedly exists ($val)"
554                 fi
555         done
556 }
557
558 t-v-tag () {
559         echo refs/tags/$tagpfx/${v//\~/_}
560 }
561
562 t-format-ref () {
563         git log -n1 --pretty=format:"$1" "$2"
564 }
565
566 t-sametree-parent () {
567         local ref=$1
568         local parent
569         local ctree=$(t-format-ref '%T' "$ref")
570         while :; do
571                 local psame=''
572                 for parent in $(t-format-ref '%P' "$ref"); do
573                         local ptree=$(t-format-ref '%T' "$parent")
574                         if [ "x$ptree" = "x$ctree" ]; then
575                                 psame+=" $parent"
576                         fi
577                 done
578                 case "$psame" in ""|" * *") break ;; esac
579                 ref="${psame# }"
580         done
581         echo "$ref"
582 }
583
584 t-check-pushed-master () {
585         local master=`t-git-get-ref refs/heads/master`
586         if [ x$master = x$t_ref_val ]; then return; fi
587         if [ x$master = x ]; then fail "failed to push master"; fi
588         # didn't update master, it must be not FF
589         local mbase=`t-git-merge-base $master $t_ref_val`
590         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
591 }
592
593 t-pushed-good () {
594         local branch=$1
595         local suite=${2:-sid}
596         t-refs-same \
597                 refs/heads/$branch
598         t-pushed-good-core
599 }
600         
601 t-pushed-good-core () {
602         t-ref-dsc-dgit
603         t-refs-same \
604                 `t-v-tag` \
605                 refs/remotes/dgit/dgit/$suite
606         t-refs-notexist \
607                 refs/heads/dgit/unstable \
608                 refs/remotes/dgit/dgit/unstable
609         (set -e; cd $dgitrepo
610          t-refs-same \
611                 refs/dgit/$suite \
612                 `t-v-tag`
613          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
614          t-refs-notexist \
615                 refs/dgit/unstable
616         )
617         git verify-tag `t-v-tag`
618 }
619
620 t-splitbrain-pushed-good--unpack () {
621         cd $tmp
622         rm -rf t-unpack
623         mkdir t-unpack
624         cd t-unpack
625         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
626         ln -s $tmp/incoming/*.orig*.tar* . ||:
627         ln -s $incoming_dsc .
628         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
629         dpkg-source "$@" -x *.dsc
630         cd */.
631         git init
632         git fetch ../../$p "refs/tags/*:refs/tags/*"
633 }
634
635 t-splitbrain-pushed-good--checkprep () {
636         git add -Af .
637         git rm --cached -r --ignore-unmatch .pc
638 }
639
640 t-splitbrain-pushed-good--checkdiff () {
641         local tag=$1
642         t-splitbrain-pushed-good--checkprep
643         t-output "" git diff --stat --cached $tag
644 }
645
646 t-splitbrain-pushed-good-start () {
647         dep14tag=refs/tags/test-dummy/${v//\~/_}
648         dgittag=$(t-v-tag)
649         t-output "" git status --porcelain
650         t-ref-head
651         t-refs-same $dep14tag
652         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
653         git merge-base --is-ancestor $dep14tag $dgittag
654
655         t-refs-same-start
656         t-ref-same refs/heads/split.p
657         case "$(t-git-get-ref refs/heads/split.b)" in
658         "$t_ref_val") ;;
659         "$(git rev-parse refs/heads/split.p^0)") ;;
660         "$(git rev-parse refs/heads/split.p^1)") ;;
661         *) fail 'bad b/p' ;;
662         esac
663         t-pushed-good-core
664
665         t-incoming-dsc
666
667         t-splitbrain-pushed-good--unpack
668         t-splitbrain-pushed-good--checkdiff $dgittag
669 }
670 t-splitbrain-pushed-good-end-made-dep14 () {
671         t-splitbrain-pushed-good--checkdiff $dep14tag
672         cd $tmp/$p
673 }
674
675 t-splitbrain-rm-gitignore-patch () {
676         perl -i -pe '
677                 next unless $_ eq "auto-gitignore\n";
678                 die if $counter++;
679                 chomp;
680                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
681                 $_ = "";
682         ' debian/patches/series
683 }
684
685 t-gbp-pushed-good () {
686         local suite=${1:-sid}
687         t-splitbrain-pushed-good-start
688
689         # Right, now we want to check that the maintainer tree and
690         # the dgit tree differ in exactly the ways we expect.  We
691         # achieve this by trying to reconstruct the maintainer tree
692         # from the dgit tree.
693
694         # So, unpack it withut the patches applied
695         t-splitbrain-pushed-good--unpack --skip-patches
696
697         # dgit might have added a .gitignore patch, which we need to
698         # drop and remove
699         t-splitbrain-rm-gitignore-patch
700
701         # Now the result should differ only in non-debian/ .gitignores
702         t-splitbrain-pushed-good--checkprep
703         git diff --cached --name-only $dep14tag >../changed
704         perl -ne '
705                 next if !m#^debian/# && m#(^|/)\.gitignore#;
706                 die "$_ mismatch";
707         ' <../changed
708
709         # If we actually apply the gitignore patch by hand, it
710         # should be perfect:
711         if [ -f ../t-auto-gitignore ]; then
712                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
713         fi
714
715         t-splitbrain-pushed-good-end-made-dep14
716 }
717
718 t-unapplied-pushed-good () {
719         t-splitbrain-pushed-good-start
720         t-splitbrain-pushed-good--unpack --skip-patches
721         t-splitbrain-pushed-good-end-made-dep14
722 }
723
724 t-dpm-pushed-good () {
725         t-splitbrain-pushed-good-start
726         t-splitbrain-pushed-good--unpack
727         t-splitbrain-rm-gitignore-patch
728         t-splitbrain-pushed-good-end-made-dep14
729 }
730
731 t-commit-build-push-expect-log () {
732         local msg=$1
733         local mpat=$2
734         t-commit "$msg"
735         t-dgit build
736         LC_MESSAGES=C \
737         t-dgit push --new 2>&1 |tee $tmp/push.log
738         t-grep-mpat "$mpat" $tmp/push.log
739 }
740
741 t-822-field () {
742         local file=$1
743         local field=$2
744         perl -e '
745                 use Dpkg::Control::Hash;
746                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
747                 $h->parse(\*STDIN,"'"$file"'");
748                 my $val = $h->{"'$field'"},"\n";
749                 die "'"$file $field"'" unless defined $val;
750                 print $val,"\n";
751         ' <$file
752 }
753
754 t-stunt-envvar () {
755         local var=$1
756         local tstunt=$2
757         eval '
758                 case "$'$var'" in
759                 "$tstunt:"*)    ;;
760                 *":$tstunt:"*)  ;;
761                 "")             '$var'="$tstunt" ;;
762                 *)              '$var'="$tstunt:$'$var'" ;;
763                 esac
764                 export '$var'
765         '
766 }
767
768 t-tstunt () {
769         local tstunt=$tmp/tstunt
770         t-stunt-envvar PATH $tstunt
771         t-stunt-envvar PERLLIB $tstunt
772         local f
773         for f in "$@"; do
774                 f="./$f"
775                 local d="$tstunt/${f%/*}"
776                 mkdir -p $d
777                 ln -sf "$troot/tstunt/$f" "$d"/.
778         done
779 }
780
781 t-tstunt-parsechangelog () {
782         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
783 }
784
785 t-tstunt-lintian () {
786         t-tstunt lintian
787 }
788
789 t-tstunt-debuild () {
790         : ${DGIT_TEST_REAL_DEBUILD:=$(type -p debuild)}
791         export DGIT_TEST_REAL_DEBUILD
792         t-tstunt debuild
793 }
794
795 t-incoming-dsc () {
796         local dsc=${p}_${v}.dsc
797         incoming_dsc=$tmp/incoming/$dsc
798 }
799
800 t-ref-dsc-dgit () {
801         t-incoming-dsc
802         local val=`t-822-field $incoming_dsc Dgit`
803         perl -e '$_=shift @ARGV; die "Dgit $_ ?" unless m/^\w+\b/;' "$val"
804         t-ref-same-val $incoming_dsc "$val"
805 }
806
807 t-apply-diff () {
808         local v1=$1
809         local v2=$2
810         (cd $troot/pkg-srcs;
811          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
812          | patch -p1 -u
813 }
814
815 t-gbp-unapplied-pq2qc () {
816         # does `gbp pq export'
817         # commits the resulting debian/patches on  qc/BRANCH
818         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
819         # qc/BRANCH is not fast-forwarding
820
821         gbp pq export
822
823         branch=`git symbolic-ref HEAD`
824         branch=${branch#refs/heads/}
825
826         case "$branch" in
827         */*) fail "unexpected branch $branch" ;;
828         esac
829
830         git branch -f qc/$branch
831         git checkout qc/$branch
832         git add debian/patches
833         git commit -m 'Commit patch queue'
834 }
835
836 t-git-pseudo-merge () {
837         # like   git merge -s ours
838         if [ ! "$git_pseuomerge_opts" ]; then
839                 if git merge --help \
840                  | grep -q allow-unrelated-histories; then
841                         git_pseuomerge_opts='--allow-unrelated-histories'
842                 fi
843                 git_pseuomerge_opts+=' -s ours'
844         fi
845         git merge $git_pseuomerge_opts "$@"
846 }
847
848 t-gbp-example-prep-no-ff () {
849         t-tstunt-parsechangelog
850         t-archive example 1.0-1
851         t-git-none
852         t-worktree 1.0
853
854         cd example
855
856         t-dgit fetch
857
858         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
859         gbp pq rebase
860
861         echo '/* some comment */' >>src.c
862         git add src.c
863         git commit -m 'Add a comment to an upstream file'
864
865         t-gbp-unapplied-pq2qc
866
867         t-commit 'some updates' 1.0-2
868 }
869
870 t-gbp-example-prep () {
871         t-gbp-example-prep-no-ff
872
873         t-git-pseudo-merge \
874                 -m 'Pseudo-merge to make descendant of archive' \
875                 remotes/dgit/dgit/sid
876 }
877
878 t-commit () {
879         local msg=$1
880         v=${2:-${majorv:-1}.$revision}
881         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
882         git add debian/changelog
883         debcommit
884         revision=$(( ${revision-0} + 1 ))
885 }
886
887 t-git-config () {
888         git config --global "$@"
889 }
890
891 t-drs () {
892         export DGIT_TEST_TROOT=$troot
893  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
894  t-git-config dgit-distro.test-dummy.git-check true
895  t-git-config dgit-distro.test-dummy.git-create true
896  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
897         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
898         cp $troot/suites $tmp/.
899         cp $troot/suites $tmp/suites-master
900
901         export t_check_pushed_master=t-check-pushed-master
902
903         drs_dispatch=$tmp/distro=test-dummy
904         mkdir $drs_dispatch
905
906         if [ "x$DGIT_TEST_INTREE" != x ]; then
907                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
908         fi
909
910         ln -sf $tmp/git $drs_dispatch/repos
911         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
912         mkdir -p $drs_dispatch/keyrings
913         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
914         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
915         ln -sf /bin/true $drs_dispatch/policy-hook
916 }
917
918 t-newtag () {
919  export tagpfx=archive/test-dummy
920  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
921 }
922 t-oldtag () {
923  export tagpfx=test-dummy
924  t-git-config dgit-distro.test-dummy.dgit-tag-format old
925 }
926
927 t-dsd () {
928         t-drs
929  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
930  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
931  t-git-config dgit-distro.test-dummy.git-create true
932  t-git-config dgit-distro.test-dummy.git-url \
933                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
934
935  t-git-config dgit-distro.test-dummy.diverts.drs /drs
936  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
937  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
938  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
939  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
940
941         echo 'no-such-package* drs' >$drs_dispatch/diverts
942 }
943
944 t-policy-admin () {
945         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
946 }
947
948 t-policy-nonexist () {
949         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
950 }
951
952 t-make-hook-link () {
953         local hook=$1 # in infra/
954         local linkpath=$2
955         hook=${DGIT_INFRA_PFX}$hook
956         case $hook in
957         */*)    ;;
958         *)      hook=`type -P $hook` ;;
959         esac
960         ln -sf "$hook" $linkpath
961 }
962
963 t-policy () {
964         local policyhook=$1
965         t-make-hook-link $policyhook $drs_dispatch/policy-hook
966 }
967
968 t-debpolicy () {
969         t-dsd
970         t-policy dgit-repos-policy-debian
971
972         mkdir $tmp/git
973         t-policy-admin create-db
974 }
975
976 t-policy-periodic () {
977         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
978                 test-dummy $drs_dispatch '' --cron
979 }
980
981 t-restrict () {
982         local restriction=$1
983         (cd $root; t-restriction-$restriction >&2)
984 }
985
986 t-dependencies () {
987         : "Hopefully installed: $*"
988 }
989
990 t-chain-test () {
991         local ct=$1
992         local d=${0%/*}
993         cd $root
994         export DGIT_TEST_TESTNAME="$testname"
995         export DGIT_TEST_TMPBASE="$tmpbase"
996         export ADTTMP=$tmp
997         exec "$d/$ct"
998 }       
999
1000 t-alt-test () {
1001         local t=${0##*/}
1002         t-${t%%-*}
1003         t-chain-test "${t#*-}"
1004 }
1005
1006 case "$0" in
1007 */gnupg) ;;
1008 *)      t-setup-import gnupg    ;;
1009 esac